package es.uva.davplov.tfg_patronlibre;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.List;

import fastDTW.dtw.TimeWarpInfo;
import fastDTW.timeseries.TimeSeries;
import fastDTW.util.DistanceFunctionFactory;
import featureCalculation.FeatureCalcultation;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;

import android.content.Intent;
import android.content.SharedPreferences;


import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.Log;

import android.view.Menu;
import android.view.MenuItem;

import android.view.View;
import android.widget.Button;

import android.widget.Toast;

/**
 * @author David Polvorosa
 * 
 * Esta es la clase principal para la prueba de patrones. En ella, se recoge una muestra del patrn libre
 * y se compara con las muestras almacenadas.
 */
public class FreePatternAccessActivity extends Activity {
	
	/** The custom view. */
	
	private DrawView mDrawView;
	private Intent i;
    private SharedPreferences pref;
    private Activity actualActivity;
    private List<Point> patronPuntosM1;
    private List<Point> patronPuntosM2;
    private List<Point> patronPuntosM3;
    private List<Point> patronPuntosM4;
    private List<Point> patronPuntosM5;
    private List<Point> patronPuntosAcceso;

	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_pattern);
        
        actualActivity=this;
        pref = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
        
        mDrawView = (DrawView) findViewById(R.id.drawView);
        
        AlertDialog.Builder builder = new AlertDialog.Builder(actualActivity);
        String mensaje;
        if (pref.getBoolean(Constants.SEGUNDASESION, false)){
        	
        	mensaje="Patrn actualizado correctamente.";

        }else{
        	
        	mensaje="Patrn creado correctamente. Se recomienda realizar una segunda sesin, para mejorar" +
	        		" la seguridad";
        }
        
        if (pref.getBoolean(Constants.MOSTRARMENSAJE, false)){
        	if (pref.getFloat(Constants.NIVELSEGURIDAD, 0)==0){
	   
        		builder.setMessage(mensaje).setCancelable(false).setPositiveButton("Ok", null); 			    	
        	}else{
        		builder.setMessage("El patrn no ha pasado la prueba de seguridad. Causas:\n" +
    	    	 		"  -Patrn muy simple\n" +
    	    	 		"  -Mucha variabilidad en su realizacin\n" +
    	    	 		"Se aconseja cambiar el patrn.").setCancelable(false).setPositiveButton("Ok", null); 
        		
        	}
        	
        	SharedPreferences.Editor editor = pref.edit();
			editor.putBoolean(Constants.MOSTRARMENSAJE, false);
			editor.commit();
			AlertDialog alert = builder.create();
			        	
	    	alert.show();
        }
	    
	    
        SharedPreferences.Editor editor = pref.edit();
        editor.putBoolean(Constants.PRIMERACCESO, false);
        editor.commit();           
          
        ((Button) findViewById(R.id.buttonRegistro)).setOnClickListener(new Button.OnClickListener() {
		
			
			//Al dar al boton Enviar, se pasan al Log todos los datos del patrn
			
			public void onClick(View v) {
				
				String patron="";
				List<Point> puntos=mDrawView.getPuntos();
				
				if (puntos.size()<10){
					Toast.makeText(actualActivity, "Debes introducir una muestra mas larga", Toast.LENGTH_SHORT).show();
					mDrawView.clear();
				}else{
					for (int cont = 0; cont < puntos.size(); cont++)	{
					
						patron=patron+Double.toString(puntos.get(cont).t) + Constants.DELIMITADOR + Double.toString(puntos.get(cont).x) + Constants.DELIMITADOR +
							Double.toString(puntos.get(cont).y) + Constants.DELIMITADOR + Integer.toString(puntos.get(cont).p)+ Constants.DELIMITADOR+ "0 0\n";
					
						}
					Log.d("Puntos","El muestra tiene estos puntos:\n"+patron);
				
					//Escribo en el fichero, los datos recogidos
			  
					listPointToFile(Constants.FICHEROACCESO,patron);
					patronPuntosAcceso=fileToListPoint(Constants.FICHEROACCESO);
					patronPuntosM1=fileToListPoint("patron1.frm");
					patronPuntosM2=fileToListPoint("patron2.frm");
					patronPuntosM3=fileToListPoint("patron3.frm");
					FeatureCalcultation conversion  = new FeatureCalcultation();
				    double[][] patronAccesoDouble;				
					double[][][] patronesDouble = new double [5][][];
					patronesDouble[0] = conversion.featureCalculation(patronPuntosM1);
					patronesDouble[1] = conversion.featureCalculation(patronPuntosM2);
					patronesDouble[2] = conversion.featureCalculation(patronPuntosM3);
					patronAccesoDouble = conversion.featureCalculation(patronPuntosAcceso);
				
					TimeSeries tsI = new TimeSeries(patronAccesoDouble, false);				
					TimeSeries tsJ = new TimeSeries(patronesDouble[0], false);
			
					final TimeWarpInfo infoM1 = 
							fastDTW.dtw.FastDTW.getWarpInfoBetween(tsI, tsJ, 2, DistanceFunctionFactory.getDistFnByName("EuclideanDistance"));
					
					tsJ = new TimeSeries(patronesDouble[1], false);
					
					final TimeWarpInfo infoM2 = 
							fastDTW.dtw.FastDTW.getWarpInfoBetween(tsI, tsJ, 2, DistanceFunctionFactory.getDistFnByName("EuclideanDistance"));
							
					tsJ = new TimeSeries(patronesDouble[2], false);
					
					final TimeWarpInfo infoM3 = 
							fastDTW.dtw.FastDTW.getWarpInfoBetween(tsI, tsJ, 2, DistanceFunctionFactory.getDistFnByName("EuclideanDistance"));
						
					mDrawView.clear();	
					SharedPreferences.Editor editor = pref.edit();
					Double distancia3Muestras= calculaDistMenor(infoM1.getDistance(), infoM2.getDistance(), infoM3.getDistance());
					Double distanciaReal=distancia3Muestras;
					
					//Si hay segunda sesin, debemos incluir en el calculo de distancias las muestras de la segunda sesin
					
			       	if (pref.getBoolean(Constants.SEGUNDASESION, false)){
			       		
			       		patronPuntosM4=fileToListPoint("patron4.frm");
						patronPuntosM5=fileToListPoint("patron5.frm");	
						patronesDouble[3] = conversion.featureCalculation(patronPuntosM4);
						patronesDouble[4] = conversion.featureCalculation(patronPuntosM5);
						tsJ = new TimeSeries(patronesDouble[3], false);
						Log.d("Ficheros", "Comparo con las 5");
						final TimeWarpInfo infoM4 = 
								fastDTW.dtw.FastDTW.getWarpInfoBetween(tsI, tsJ, 2, DistanceFunctionFactory.getDistFnByName("EuclideanDistance"));
						
						tsJ = new TimeSeries(patronesDouble[4], false);
						
						final TimeWarpInfo infoM5 = 
								fastDTW.dtw.FastDTW.getWarpInfoBetween(tsI, tsJ, 2, DistanceFunctionFactory.getDistFnByName("EuclideanDistance"));
						
						distanciaReal=calculaDistMenor(distancia3Muestras,infoM4.getDistance(),infoM5.getDistance());
						
			       	}		
			       	
			       	editor.putFloat(Constants.UMBRALPATRON, Float.parseFloat(Double.toString(distanciaReal)));
					editor.commit();
					i= new Intent(actualActivity, Results.class);
					startActivity(i);
			
				}
			}
		
		});
        
        ((Button) findViewById(R.id.buttonReset)).setOnClickListener(new Button.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				mDrawView.clear();
			}
		});
        
    }
    
	/**
	 * 
	 * @param dis1 Distancia 1 respecto a la muestra de acceso
	 * @param dis2 Distancia 2 respecto a la muestra de acceso
	 * @param dis3 Distancia 3 respecto a la muestra de acceso
	 * @return
	 */
    public double calculaDistMenor(Double dis1,Double dis2,Double dis3){
    	
    	double dismenor;
    	
    	
    	
    	if (dis1<=dis2){
    		if(dis1<=dis3){
    			dismenor=dis1;
    		}else{
    			dismenor=dis3;
    		}
    	}else{
    		if(dis2<=dis3){
    			dismenor=dis2;
    		}else{
    			dismenor=dis3;
    		}
    		
    	}
    	
    	Log.d("DistMenor", "Patron de distancia :" + Double.toString(dismenor));
    	return dismenor;
    }
    
    public boolean onCreateOptionsMenu(Menu menu) {
    	
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
       
    public boolean onOptionsItemSelected(MenuItem item) {
    	SharedPreferences.Editor editor = pref.edit();
    	Intent i= new Intent();
    		switch (item.getItemId()) {
            case R.id.repetirPatron:
            	
            	i=new Intent(actualActivity, FreePatternIncomeActivity.class);
               	editor.putBoolean(Constants.TIENEPATRON, false);
            	editor.commit();   
            	
            	startActivity(i);
                actualActivity.finish();
                return true;
                
            case R.id.segundaSesion:
            	           		
            		i=new Intent(actualActivity, FreePatternIncomeActivitySecondSession.class);
            		editor.putBoolean(Constants.SEGUNDASESION, false);
                	editor.commit();  
            		startActivity(i);
            		actualActivity.finish();
            
                return true;
            	
            default:
               
                return false;
        }
    	
    }
    
   
    public void listPointToFile(String nombreFichero, String patron) {

		try {
			OutputStreamWriter fileout = new OutputStreamWriter(openFileOutput(
					nombreFichero, Context.MODE_PRIVATE));
			fileout.write(patron);
			fileout.close();
		} catch (Exception ex) {
			Log.e("Ficheros", "Error al escribir fichero a memoria interna");
		}

	}
    
    public List<Point> fileToListPoint(String nombreFichero){
    	
    	List<Point> patron = new ArrayList<Point>();
    	String texto;
    	Point puntoPatron;
    	try
		{
		    BufferedReader fin = new BufferedReader(new InputStreamReader(openFileInput(nombreFichero)));
		    
		    while((texto=fin.readLine())!=null){
		    	
		    	String[] array= texto.split(Constants.DELIMITADOR);
		    	
		    	puntoPatron = new Point(Double.parseDouble(array[Constants.POSICIONX-1]),Double.parseDouble(array[Constants.POSICIONY-1])
		    			,Double.parseDouble(array[Constants.POSICIONTIEMPO-1]), Integer.parseInt(array[Constants.POSICIONPULSACION-1]));
		    	patron.add(puntoPatron);
		 
		    }
		    
		    fin.close();
		}
		catch (Exception ex)
		{
		    Log.e("Ficheros", "Error al leer fichero desde memoria interna");
		}
    	
    	return patron;
    	
    }
    
	
}
