package es.uva.davplov.tfg_patronlibre;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.List;

import srcPruebaSeguridad.PruebaSeguridad;
import srcUmbral.MisExcepciones.UmbralException;
import srcUmbral.umbral.UmbralPrincipal;

import featureCalculation.FeatureCalcultation;
import android.os.AsyncTask;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.util.Log;

import android.view.View;
import android.widget.Button;
import android.widget.Toast;

/**
 * 
 * @author David Polvorosa Hoyos
 * 
 * Esta clase es la actividad encargada de aadir una segunda inscripcin. 
 *
 */

public class FreePatternIncomeActivitySecondSession extends Activity {

	private DrawView mDrawView;
	private static ProgressDialog progressDialog;
	private int veces;
    private SharedPreferences pref;
    private Activity actualActivity;
    private String nombrePatronActual;
  
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_pattern);
        
        //Inicializacin de variables
       
        nombrePatronActual=" ";
        actualActivity=this;  
        new ArrayList<Point>();
        pref = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
        mDrawView = (DrawView) findViewById(R.id.drawView);
        
        SharedPreferences.Editor editor = pref.edit();
	    editor.putBoolean(Constants.SEGUNDASESIONACABADA,false);
	    editor.commit();
	    
        veces=0;
        //Creacin del dilogo de carga entre muestra y muestra 
        
        progressDialog = new ProgressDialog(this);        
	    progressDialog.setMessage("Guardando muestra"); 
	    progressDialog.setIndeterminate(true);
	    progressDialog.setCancelable(false);
	    
        //Creacin de el dilogo que explica lo que hay que hacer en la aplicacin
	    
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        builder.setMessage("Estas en la pantalla de aadir segunda sesin. Por favor ingrese sus dos muestras"
        		).setCancelable(false).setPositiveButton("Ok", null);
              
        AlertDialog alert = builder.create();
       
        	
        	alert.show();
   
        ((Button) findViewById(R.id.buttonRegistro)).setOnClickListener(new Button.OnClickListener() {
			
		//Al dar al boton Enviar, se pasan al Log todos los datos del patrn
			
			public void onClick(View v) {
				
					String patron="";
					nombrePatronActual="patron"+Integer.toString(veces+4)+".frm";
					List<Point> puntos=mDrawView.getPuntos();
					
					if (puntos.size()<10){
						Toast.makeText(actualActivity, "Debe ingresar una muestra ms larga", Toast.LENGTH_SHORT).show();
						mDrawView.clear();
					}else{
						for (int cont = 0; cont < puntos.size(); cont++)	{
						
							patron=patron+Double.toString(puntos.get(cont).t) + Constants.DELIMITADOR + Double.toString(puntos.get(cont).x) + Constants.DELIMITADOR +
								Double.toString(puntos.get(cont).y) + Constants.DELIMITADOR + Integer.toString(puntos.get(cont).p)+ Constants.DELIMITADOR+ "0 0\n";
						
							}
						Log.d("Puntos","El patrn se representa por los siguientes puntos:\n"+patron);
					
						//Escribo en el fichero, los datos recogidos
				
						listPointToFile(nombrePatronActual,patron);
						
						if (veces>=1){
							
							    progressDialog.setMessage("Calculando umbrales. Este proceso puede durar varios minutos");
							    
						}
						new BarraProgreso().execute(veces);
						veces++;
				
						mDrawView.clear();	
				
					}
			}
		
		});
        
        ((Button) findViewById(R.id.buttonReset)).setOnClickListener(new Button.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				mDrawView.clear();
				
			}
		});
        
        
    }
    
    /**
     * 
     * @param nombreFichero Nombre del fichero a que contendr el patrn
     * @param patron Cadena a meter en el fichero
     */
    
	public void listPointToFile(String nombreFichero, String patron) {

		try {
			OutputStreamWriter fileout = new OutputStreamWriter(openFileOutput(
					nombreFichero, Context.MODE_PRIVATE));
			fileout.write(patron);
			fileout.close();
		} catch (Exception ex) {
			Log.e("Ficheros", "Error al escribir fichero a memoria interna");
		}

	}
	/**
	 * 
	 * @param nombreFichero Fichero del que se obtendr la lista de puntos
	 * @return Lista de puntos 
	 */
	
    public List<Point> fileToListPoint(String nombreFichero){
    	
    	List<Point> patron = new ArrayList<Point>();
    	String texto;
    	Point puntoPatron;
    	try
		{
    		InputStreamReader fin=new InputStreamReader(openFileInput(nombreFichero));
		    BufferedReader bin = new BufferedReader(fin);
		    
		    while((texto=bin.readLine())!=null){
		    	
		    	String[] array= texto.split(Constants.DELIMITADOR);
		    	
		    	puntoPatron = new Point(Double.parseDouble(array[Constants.POSICIONX-1]),Double.parseDouble(array[Constants.POSICIONY-1])
		    			,Double.parseDouble(array[Constants.POSICIONTIEMPO-1]), Integer.parseInt(array[Constants.POSICIONPULSACION-1]));
		    	patron.add(puntoPatron);
		    	
		    }
		    
		    bin.close();
		    fin.close();
		}
		catch (Exception ex)
		{
		    Log.e("Ficheros", "Error al leer fichero desde memoria interna");
		}
    	
    	return patron;
    	
    }
    
    /**
     * 
     * @return Array triple que contiene los datos del cohorte
     */
    
    	private double[][][] getCoh(){
    	
    	 double[][][] patronesCoh = new double[39][][];
       	 Point puntoPatron;
     	 List<Point> patron = new ArrayList<Point>();
       	 String texto;
    	  
       	 int id= R.raw.c001;
    	//Recorremos todos los ficheros de raw, sabiendo que sus ID son consecutivos
    	for (int i=0;i<39;i++){
    		
    	try
    	
		{
		   InputStream fraw = getResources().openRawResource(id+i);
		    
		    BufferedReader brin =
		        new BufferedReader(new InputStreamReader(fraw));
		   		    
		    texto=brin.readLine();
		    while (brin.ready()){
		    	String[] array= texto.split(Constants.DELIMITADOR);
		    	
		    	puntoPatron = new Point(Double.parseDouble(array[Constants.POSICIONX_Coh-1]),Double.parseDouble(array[Constants.POSICIONY_Coh-1])
		    			,Double.parseDouble(array[Constants.POSICIONTIEMPO_Coh-1]), getPulsacion(array[Constants.POSICIONPULSACION_Coh-1]));
		    	
		    	patron.add(puntoPatron);
		    	texto=brin.readLine();	
		    	
		    }
		    FeatureCalcultation conversion= new FeatureCalcultation();
		    patronesCoh[i]=conversion.featureCalculation(patron);
		    
		    patron.clear();
		    fraw.close();
		    brin.close();
		}
		catch (Exception ex)
		{
		    Log.e("Ficheros", "Error al leer fichero desde recurso raw");
		}
    	}
    	return patronesCoh;
    	
      	
    }
    	/**
         * 
         * @return Array triple que contiene los datos de desarrollo
         */
    	
    	private double[][][] getDev(){
        	
          	 double[][][] patronesDev = new double[32][][];
             	 Point puntoPatron;
           	 List<Point> patron = new ArrayList<Point>();
             	 String texto;
          	  
             	 int id= R.raw.d1;
          	//Recorremos todos los ficheros de raw, sabiendo que sus ID son consecutivos
          	for (int i=0;i<32;i++){
          		
          	try
          	
      		{
      		   InputStream fraw = getResources().openRawResource(id+i);
      		    
      		    BufferedReader brin =
      		        new BufferedReader(new InputStreamReader(fraw));
      		   		    
      		    texto=brin.readLine();
      		    while (brin.ready()){
      		    	String[] array= texto.split(Constants.DELIMITADOR);
      		    	
      		    	puntoPatron = new Point(Double.parseDouble(array[Constants.POSICIONX_Coh-1]),Double.parseDouble(array[Constants.POSICIONY_Coh-1])
      		    			,Double.parseDouble(array[Constants.POSICIONTIEMPO_Coh-1]), getPulsacion(array[Constants.POSICIONPULSACION_Coh-1]));
      		    	
      		    	patron.add(puntoPatron);
      		    	texto=brin.readLine();	
      		    	
      		    }
      		    FeatureCalcultation conversion= new FeatureCalcultation();
      		    patronesDev[i]=conversion.featureCalculation(patron);
      		    
      		    patron.clear();
      		    fraw.close();
      		    brin.close();
      		}
      		catch (Exception ex)
      		{
      		    Log.e("Ficheros", "Error al leer fichero desde recurso raw");
      		}
          	}
          	return patronesDev;
          	
            	
          }
    public int getPulsacion(String pulsacionBoolean){
    	int pulsacion=0;
    	if (pulsacionBoolean=="false"){
    		pulsacion=1;
    	}
    	
    	return pulsacion;
    	}
    
    /**
     * 
     * @author David Polvorosa
     * Esta clase permite crear el dialogo de mensaje de espera
     * 
     */
    private class BarraProgreso extends AsyncTask<Integer, Void, String> {
	    
    	
	    @Override
		protected void onPreExecute() {
	    	
	    	progressDialog.show();
	    	
	    }
		protected void onPostExecute(final String respuesta) {			
		
				progressDialog.dismiss();
				
		//Si la muestra es la numero 2 entonces llamamos a la actividad de acceso mediante 
				//patrn 
				
				if (veces>Constants.MUESTRAS_SEGUNDASESION-1){
					
					startActivity(new Intent(getApplicationContext(), FreePatternAccessActivity.class));
					
				
					SharedPreferences.Editor editor = pref.edit();
					
					editor.putBoolean(Constants.TIENEPATRON, true);
					
					editor.commit();
					
					actualActivity.finish();
					
				}else{
					Toast.makeText(getApplicationContext(), Integer.toString(veces) + " muestras tomadas de "+
							Integer.toString(Constants.MUESTRAS_SEGUNDASESION), Toast.LENGTH_SHORT).show();
					
					
					
				}
			
	}
		protected String doInBackground(Integer... params) {
						
			//Para crear una espera proporcional al numero de muestra, hacemos dormir al hilo dependiendo de las muestras tomadas
			//en las dos primeras. Si es la tercera muestra, se calculan los umbrales
			if (veces>Constants.MUESTRAS_SEGUNDASESION-1){
				
				//Obtengo los 5 patrones del patron
				FeatureCalcultation conversion  = new FeatureCalcultation();			
				double[][][] patronesDouble = new double [5][][];
				double[][][]patronesCoh= new double[39][][];
				double[][][]patronesDev= new double[32][][];
				List<Point> patronPuntosM1=fileToListPoint("patron1.frm");
				List<Point> patronPuntosM2=fileToListPoint("patron2.frm");
				List<Point> patronPuntosM3=fileToListPoint("patron3.frm");
				List<Point> patronPuntosM4=fileToListPoint("patron4.frm");
				List<Point> patronPuntosM5=fileToListPoint("patron5.frm");
				patronesDouble[0] = conversion.featureCalculation(patronPuntosM1);
				patronesDouble[1] = conversion.featureCalculation(patronPuntosM2);
				patronesDouble[2] = conversion.featureCalculation(patronPuntosM3);
				patronesDouble[3] = conversion.featureCalculation(patronPuntosM4);
				patronesDouble[4] = conversion.featureCalculation(patronPuntosM5);
				
				//Obtengo las muestras de cohorte
				
				patronesCoh=getCoh();
				double[] umbrales=new double[4];
				Log.d("Ficheros", "He conseguido las muestras de cohorte");
			    UmbralPrincipal umbral=new UmbralPrincipal();
			   
			    try {
			    	umbrales=umbral.CalculaUmbral(patronesDouble, patronesCoh, 2);
				} catch (UmbralException e) {
					
					e.printStackTrace();
				}
			    
			    patronesDev=getDev();
			    PruebaSeguridad pruebaSeg=new PruebaSeguridad();
			    double valorSeguridad=0;
			    
			    try {
			    	valorSeguridad=pruebaSeg.pruebaSeguridad(patronesDouble, patronesDev);
				} catch (UmbralException e) {
					
					e.printStackTrace();
				}
			    SharedPreferences.Editor editor = pref.edit();
			    editor.putFloat(Constants.UMBRALALTO, Float.parseFloat(Double.toString(umbrales[1])));
				editor.putFloat(Constants.UMBRALMEDIO, Float.parseFloat(Double.toString(umbrales[2])));
				editor.putFloat(Constants.UMBRALBAJO, Float.parseFloat(Double.toString(umbrales[3])));
				editor.putFloat(Constants.NIVELSEGURIDAD, Float.parseFloat(Double.toString(valorSeguridad)));
				editor.putBoolean(Constants.SEGUNDASESION, true);
				editor.putBoolean(Constants.MOSTRARMENSAJE, true);
				editor.putBoolean(Constants.SEGUNDASESIONACABADA, true);
				editor.commit();
				
			    Log.d("Ficheros", "UMBRAL1 "+ Double.toString(umbrales[0]));
			    Log.d("Ficheros", "UMBRAL2 "+ Double.toString(umbrales[1]));
			    Log.d("Ficheros", "UMBRAL3 "+ Double.toString(umbrales[2]));
			    Log.d("Ficheros", "UMBRAL4 "+ Double.toString(umbrales[3]));
			    
			}else{
				try {
					Thread.sleep(Constants.SEGUNDO*veces); 
				}
				catch (InterruptedException e) {
            	
				}
		}
		return null;
	}
		
	
		
		
		
  }      
         	
    	
}

