package srcUmbral.configuracion;

import fastDTW.util.DistanceFunction;
import fastDTW.util.DistanceFunctionFactory;

/*
 * Esta clase contiene las variables de configuracion de la aplicacion.
 * La idea es cetralizar aqui todo lo referente a esto
 */
public class Configuracion {
	
	//Ruta de partida de almacenamiento de ficheros de firmas
	public static String RUTA_RAIZ = "C:/Users/biowam/Experimentos_BioWam/Pruebas/";  // Ruta pruebas
	//public static String RUTA_RAIZ = "/var/www/BioSignWeb/";  // ruta servidor
	
	// Para calculo del umbral
	public static String RUTA_COHORTE = RUTA_RAIZ + "Datos/BioWamCohort";  // Ruta pruebas
	//public static String RUTA_COHORTE = RUTA_RAIZ + "ficheros_cohorte/cohort150-2";  // Ruta servidor
	
	// Relacionados con el almacenamiento de los ficheros de firmas
	public static String FICHS_DIR = "Firmas";  // Nombre pruebas
	//public static String FICHS_DIR = "ficheros_firmas"; // Nombre servidor
	public static String FICHS_INS = "fichs_ins.txt";
	public static String MODELO_INS = "modelo_ins.txt";
	
	// Para calculo de EER
	public static boolean aplicar_media_si_EER_0 = true;
	
	// Procesamiento firma
	public static boolean INTERPOLAR = false;
	public static boolean NORMALIZAR_TAMANNO = false;
	public static boolean ZNORM = true;
	public static boolean MIRRORIZE = false;
	
	// Ficheros de logs
	public static String SUCESS_FILE = RUTA_RAIZ + "Logs/log.txt";
	public static String ERROR_FILE = RUTA_RAIZ + "Logs/logError.txt";
	
	// Ficheros para prediccion de umbral mediante regresion lineal
	public static String PL_FICHS_DIR = "Ficheros_PL"; 
	
	// Hay determinado procesamientos que depende del tipo de fichero. Para eso
	//definimos esta variable. Se guarda la extension. Vamos a diferenciar la fuente
	//de la firma mediane la extension
	public static String tipoFichero;
	
	// Hay una pequenna diferencia entre los scores obtenido aqui y los obtenidos en Tres_Sistemas.
	// La unica diferencia es la normalizacion al centro de masas: aqui el punto (0,0), en 
	//Tres_Sistemas al centro de masas de la primera firma. Annadimos estas variables para
	//hacerlo de la misma manera.
	public static double CmXFMod1;
	public static double CmYFMod1;
	public static boolean NormCMFMod1 = false;  // si usar esto o la del punto (0,0)
	
	// Cdigos errores retorno. Uso cantidades decimales que en binario solo tienen un 1
	//para asi poder enviar varios
	// -2: error general
	// -4: error al abrir el fichero de log (en Log.java)
	
	// Variable para indicar donde se define el modelo de regresin
	public static String RegresionModel = "clase";   // Valores: clase/fichero
	
	// Variables para fastDTW
	public static String distanceType = "EuclideanDistance";  //Valores: EuclideanDistance|ManhattanDistance|BinaryDistance
	public static DistanceFunction distFn = DistanceFunctionFactory.getDistFnByName(distanceType);
	public static int radio = 6;  // parametro para fastDTW

}
