package srcUmbral.firmweb.util;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

public class ArraysUtil {

	/**
	 * 
	 * @param array
	 */
	public static void print(int[] array) {
		for (int i = 0; i < array.length; i++) {
			System.out.println(array[i]);
		}
	}

	/**
	 * 
	 * @param array
	 */
	public static void print(int[][] array) {
		for (int i = 0; i < array.length; i++) {
			for (int j = 0; j < array[i].length; j++) {
				System.out.print(array[i][j] + "\t");
			}
			System.out.println();
		}
	}

	/**
	 * 
	 * @param array
	 */
	public static void print(double[] array) {
		for (int i = 0; i < array.length; i++) {
			System.out.println(array[i]);
		}
	}

	/**
	 * 
	 * @param array
	 */
	public static void print(double[][] array) {
		for (int i = 0; i < array.length; i++) {
			for (int j = 0; j < array[i].length; j++) {
				System.out.print(array[i][j] + "\t");
			}
			System.out.println();
		}
	}

	/**
	 * Copy a two-dimensions array of doubles into an two-dimension array of
	 * integers.
	 * 
	 * @param intArr
	 *            The integers array.
	 * @return The doubles array.
	 */
	public static double[][] copy(int[][] intArr) {
		double[][] doubleArr = new double[intArr.length][];
		for (int i = 0; i < doubleArr.length; i++) {
			doubleArr[i] = new double[intArr[i].length];
			for (int j = 0; j < doubleArr[i].length; j++) {
				doubleArr[i][j] = intArr[i][j];
			}
		}
		return doubleArr;
	}

	/**
	 * 
	 * @param datos
	 * @return
	 */
	public static double[][] copy(double[][] doubleArr) {
		double[][] doubleArrCopy = new double[doubleArr.length][];
		for (int i = 0; i < doubleArrCopy.length; i++) {
			doubleArrCopy[i] = new double[doubleArr[i].length];
			for (int j = 0; j < doubleArrCopy[i].length; j++) {
				doubleArrCopy[i][j] = doubleArr[i][j];
			}
		}
		return doubleArrCopy;
	}

	/**
	 * 
	 * @param datos
	 * @return
	 */
	public static double[][] copy(ArrayList<double[]> doubleArr) {
		double[][] doubleArrCopy = new double[doubleArr.size()][];
		for (int i = 0; i < doubleArrCopy.length; i++) {
			doubleArrCopy[i] = new double[doubleArr.get(i).length];
			for (int j = 0; j < doubleArrCopy[i].length; j++) {
				doubleArrCopy[i][j] = doubleArr.get(i)[j];
			}
		}
		return doubleArrCopy;
	}

	/**
	 * 
	 * @param intArr
	 * @return
	 */
	public static int[][] copyInt(ArrayList<int[]> intArr) {
		int[][] intArrCopy = new int[intArr.size()][];
		for (int i = 0; i < intArrCopy.length; i++) {
			intArrCopy[i] = new int[intArr.get(i).length];
			for (int j = 0; j < intArrCopy[i].length; j++) {
				intArrCopy[i][j] = intArr.get(i)[j];
			}
		}
		return intArrCopy;
	}

	/**
	 * 
	 * @param data
	 * @param numColumn
	 * @return
	 */
	public static double[] column(double[][] data, int numColumn) {
		double[] column = new double[data.length];
		for (int i = 0; i < data.length; i++) {
			column[i] = data[i][numColumn];
		}
		return column;
	}

	/**
	 * 
	 * @param txypai
	 * @param t
	 * @param numPoints
	 * @return
	 */
	public static double[] column(double[][] data, int numColumn, int numPoints) {

		int nPoints = Math.min(data.length, numPoints);
		double[] column = new double[nPoints];
		for (int i = 0; i < column.length; i++) {
			column[i] = data[i][numColumn];
		}
		return column;
	}

	/**
	 * 
	 * @param a
	 * @param b
	 * @return
	 */
	public static double[][] combine(double[] a, double[] b) {
		int nf = Math.min(a.length, b.length);
		double[][] ab = new double[nf][2];
		for (int i = 0; i < nf; i++) {
			ab[i][0] = a[i];
			ab[i][1] = b[i];
		}
		return ab;
	}

	/**
	 * 
	 * @param a
	 * @param b
	 * @param c
	 * @return
	 */
	public static double[][] combine(double[] a, double[] b, double[] c) {
		int nf = Math.min(a.length, Math.min(b.length, c.length));
		double[][] z = new double[nf][3];
		for (int i = 0; i < nf; i++) {
			z[i][0] = a[i];
			z[i][1] = b[i];
			z[i][2] = c[i];
		}
		return z;
	}

	/**
	 * 
	 * @param datosFirmaFiltered
	 * @param col
	 * @param value
	 * @return
	 */
	public static int[][] substract(int[][] array, int col, int value) {
		for (int i = 0; i < array.length; i++) {
			array[i][col] -= value;
		}
		return array;
	}
	
	/**
	 * 
	 * @param datosFirmaFiltered
	 * @param col
	 * @param value
	 * @return
	 */
	public static double[][] substract(double[][] array, int col, double value) {
		for (int i = 0; i < array.length; i++) {
			array[i][col] -= value;
		}
		return array;
	}

    public static int[][] SumaTimeStamp(int[][] array) {
        int t = array[0][0];
        for (int i=1; i<array.length; i++) {
            t += array[i][0];
            array[i][0] = t;
        }
        return array;
    }
    
    public static double[][] SumaTimeStamp(double[][] array) {
        double t = array[0][0];
        for (int i=1; i<array.length; i++) {
            t += array[i][0];
            array[i][0] = t;
        }
        return array;
    }
    
    /*
     * Suma los timestamp para los ficheros .ascii que son los de cohorte
     * En vez de modificar los ficheros, aadirmos este metodo
     */
    public static int[][] SumaTimeStampASCII(int[][] array) {
        int T = 10;  // periodo de muestreo en ms
    	array[0][0] = 0;
    	int t = 0;
        for (int i=1; i<array.length; i++) {
            t += 10;
            array[i][0] = t;
        }
        return array;
    }
    
    /*
     * Suma los timestamp para los ficheros .ascii que son los de cohorte
     * En vez de modificar los ficheros, aadirmos este metodo
     */
    public static double[][] SumaTimeStampASCII(double[][] array) {
        int T = 10;  // periodo de muestreo en ms
    	array[0][0] = 0.0;
    	int t = 0;
        for (int i=1; i<array.length; i++) {
            t += 10;
            array[i][0] = (double) t;
        }
        return array;
    }
    
    /**
	 * Inicializa un array a un valor
	 * 
	 * @param value
	 * @return
	 */
	public static double[] createArray(int size, double initialValue) {
		double[] array = new double[size];
		for (int i = 0; i < array.length; i++) {
			array[i] = initialValue;
		}
		return array;
	}
	
	/**
	 * 
	 * @param scoCliUsers
	 * @return
	 */
	public static double[] merge(double[][] matrix) {
		ArrayList<Double> list = new ArrayList<Double>();
		for (int i = 0; i < matrix.length; i++) {
			for (int j = 0; j < matrix[i].length; j++) {
				list.add(matrix[i][j]);
			}
		}
		return collectionToArrayOfDoubles(list);
	}
	
	/**
	 * Integer collection to int array
	 * 
	 * @param collection
	 *            The source collection.
	 * @return The int array.
	 */
	public static double[] collectionToArrayOfDoubles(Collection<Double> col) {
		if (col == null)
			return null;
		int L = col.size();
		double[] array = new double[L];
		Iterator<Double> iter = col.iterator();
		int i = 0;
		while (iter.hasNext()) {
			Double element = (Double) iter.next();
			array[i] = element;
			i++;
		}
		return array;
	}
	
	/**
	 * 
	 * @param list
	 * @return
	 */
	public static double[] toDoubleArray(ArrayList<Double> list) {
		double[] array = new double[list.size()];
		for (int i = 0; i < array.length; i++) {
			array[i] = list.get(i);
		}
		return array;
	}
	
	/**
	 * Metodo para igualar tamao vector caracteristicas en caso de calcular velocidades
	 * 
	 * @param datos
	 * @return
	 */
	public static double[] duplicarUltimaColumna(double[] datos) {
		double[] datosRetorno = new double[datos.length + 1];
		int i;
		for (i=0; i<datos.length; i++) {
			datosRetorno[i] = datos[i];
		}
		datosRetorno[i] = datosRetorno[i-1];
		return datosRetorno;
	}
	
	/**
	 * Calcula la traspuesta de una matriz
	 * 
	 * @param matrix
	 * @return
	 */
	public static double[][] traspose(double[][] matrix) {
		int nf = matrix.length;
		int nc = matrix[0].length;
		double[][] matrix_t = new double[nc][nf];
		for (int i = 0; i < matrix.length; i++) {
			for (int j = 0; j < matrix[i].length; j++) {
				matrix_t[j][i] = matrix[i][j];
			}
		}
		return matrix_t;
	}
	
	/**
	 * 
	 * @param maxValue
	 * @return
	 */
	public static int countValues(double[][] matrix, double value) {
		int num = 0;
		for (int i = 0; i < matrix.length; i++) {
			if (vectorContiene(matrix[i], value))
				num++;
		}
		return num;
	}
	
	/**
	 * 
	 * @param vector
	 * @param value
	 * @return
	 */
	public static boolean vectorContiene(double[] vector, double value) {
		for (int i = 0; i < vector.length; i++) {
			if (vector[i] == value) {
				return true;
			}
		}
		return false;
	}


}
